# Renardo Tutorials

This directory contains tutorial files for Renardo organized by language.

## Structure

- `en/` - English tutorials
- `es/` - Spanish (Español) tutorials

## Adding New Languages

To add tutorials in a new language:

1. Create a new directory with the language code (e.g., `fr` for French, `de` for German)
2. Copy the English tutorial files as a template
3. Translate the content while keeping the file names consistent
4. The webclient will automatically detect and display the new language

## File Naming Convention

Tutorial files should be named with a numeric prefix to ensure proper ordering:
- `00_intro.py`
- `01_playing_notes.py`
- `02_algorithmic_manipulation.py`
- etc.

## Usage

These tutorial files are displayed in the Renardo web interface. Users can:
- Select their preferred language from a dropdown menu
- Click on any tutorial to load it into the code editor
- Execute the code examples to learn Renardo concepts